       TITL ' TMS32011 MODEM TABLES '
       IDT  'TABLES'
       OPTION XREF,TUNLST
********------------------------------------------********
*****  These are the tables used in the TMS32011     *****
*****  modem code.  This must be the first module    *****
*****  linked to assure the tables in low addresses. *****
*****  This code also include the initialization     *****
*****  routines and command handler.		     *****
*****						     *****
*****  MODULE BUILT BY PETER EHLIG  12/02/85	     *****
*****  REVISION 1.1		    1/11/86	     *****
*****						     *****
*****  COPYRIGHT TEXAS INSTRUMENTS,  07/25/86	     *****
*****						     *****
********------------------------------------------********
************************************************************
****  MODEM RECEIVER STATUS REGISTER DEFINITIONS BIT	****
****	0   LSB OF RECEIVE DIBIT OR DATA BIT OF 300BPS	****
****	1   MSB OF RECEIVE DIBIT BIT 1 OF V.22BIS	****
****	2   ANS.TONE /W.MODM XMT SQLCH (V.22BIT QUADBIT)****
****	3   MSB OF V.22BIS QUADBIT			****
****	4   CARRIER DETECT ACTIVE HIGH			****
****	5   ENERGY DETECT ACTIVE HIGH			****
****	6   BAUD ALIGNMENT ENABLE ACTIVE LOW		****
****	7   ANSWER(-) OR ORIGINATE (+)			****
****	8-15 RESERVED					****
************************************************************
****   COMMAND/CONFIGURATION DATA BIT DEFINITIONS	****
**** -------------------------------------------------- ****
****|CMND2 | CMND2 | DATA 4 | DATA 3 | DATA 2 | DATA 1 |****
**** -------------------------------------------------- ****
**** COMMAND BITS     |   00   IDLE			****
**** DESCRIPTION      |   01   DIAL A NUMBER		****
****		      |   10   RUN MODEM AS CONFIGURED	****
****		      |   11   CONFIGURE MODEM		****
************************************************************
****	CONFIGURATION COMMAND CODES			****
****							****
****	0000 RUN BELL 212 MODEM 			****
****	0001 RUN LOCAL DIGITAL LOOPBACK 		****
****	0010 RUN ANALOG LOOPBACK			****
****	0011 INITIALIZE TO ORIGINATE MODE		****
****	0100 INITIALIZE TO ANSWER MODE			****
****	0101 RUN BELL 103 MODEM 			****
****	1101 RUN BELL 103 MODEM/SQUELCH TRANSMIT	****
****	0110 RUN V.21 MODEM				****
****	0111 RUN V.22 MODEM				****
****	1000 RUN V.22BIS MODEM				****
****	0110-1000 NOT YET IMPLEMENTED			****
****	1100 RUN 1200 ANS/W.ANS TONE,SQLCH MODM XMIT	****
****	1001-1111 RESERVED FOR FUTURE EXPANSION 	****
**********************************************************
*****	  32011 SERIAL PORT INITIALIZATION TABLE     *****
*****------------------------------------------------*****
*****  BITS0-3= >F  RESET ALL INTERRUPT FLAGS	     *****
*****  BITS4-7= 0   INTERRUPT MASK BITS (DISABLE)    *****
*****  BIT8 = 1  ACCESS COUNTER/CLOCK SCALER ACCESS  *****
*****  BIT9 = 0  SERIAL PORT FRAMED USING FR	     *****
*****  BIT11= 1  SERIAL PORT ENABLED		     *****
*****  BIT12= 1  ENABLE uLAW ENCODER		     *****
*****  BIT13= 1  ENABLE uLAW DECODER		     *****
*****  BIT14= 0  COMPANDING TYPE SET TO uLAW	     *****
*****  BIT15= 0  TIMING SET USING PRESCALER	     *****
*****  BITS0-3,10  DONT CARE			     *****
*****  INISP1 = >390F				     *****
*****						     *****
*****  BITS16-23 = >BE	FRAME COUNTER VALUE (192)    *****
*****  BITS24-27 = >C	SCLK PRESCALER		     *****
*****  BIT28= 1  VARIABLE DATA RATE		     *****
*****  BITS29-31 DONT CARE			     *****
*****  INISP2 = >1CBE				     *****
*****						     *****
********------------------------------------------********
       PAGE
       DEF  TONTBL,LBSP,LBMK,HBSP,HBMK
       DEF  PLLC,BPLLC,SETUPA,SETUPO,DT1
       DEF  TSKSEQ,TSKXMT,ORGCOF,ANSCOF,COEF
       DEF  AGCTBL,SINE,COMD
       REF  DUMMY,BDCLK2,TRENDS,OUT,DECODE
       REF  DEMODB,AGCUPT,BDCLK1,DEBUG,BAUDST
       REF  GETDBT,DUMXMT
       REF  ANALOG,DIAL,WAIT,RUN12,RUN103,RSQ103
       REF  RUN12A
       B    START
       PAGE
       COPY TASKMAS.EQU
********------------------------------------------********
*****	    TRANSMITTER DIBIT ENCODER TABLE.	     *****
********------------------------------------------********
ENCODE	DATA	>0002	    * DIBIT '01' = 90 deg.
	DATA	>0000	    * DIBIT '00' = 0 deg.
	DATA	>0004	    * DIBIT '10' = 180 deg
	DATA	>0006	    * DIBIT '11' = 270 deg.
XPHASE	DATA	>7FFF	    * 0 deg.   I CHANNEL =  1
	DATA	>0000	    *	       Q CHANNEL =  0
	DATA	>0000	    * 90 deg.  I CHANNEL =  0
	DATA	>8000	    *	       Q CHANNEL = -1
	DATA	>8000	    * 180 deg. I CHANNEL = -1
	DATA	>0000	    *	       Q CHANNEL =  0
	DATA	>0000	    * 270 deg. I CHANNEL =  0
	DATA	>7FFF	    *	       Q CHANNEL =  1
********------------------------------------------********
*****	    RECEIVER DIBIT ENCODER TABLE.	     *****
*****	    DIBITS are formed as 'MSB,LSB'.          *****
********------------------------------------------********
RPHASE	DATA	>0001	    * 0  deg.,	DIBIT = '01'
	DATA	>0000	    * 90 deg.,	DIBIT = '00'
	DATA	>0002	    * 180 deg., DIBIT = '10'
	DATA	>0003	    * 270 deg., DIBIT = '11'
*
M1	DATA	>7FFF
M2	DATA	>007F
M3	DATA	>0006
CK	DATA	>0208	    * CLOCK FOR AIB
MD	DATA	>000A	    * MODE FOR AIB
ST	DATA	>1800
	DATA	>0000
DT	DATA	>1000	    * TRANSMIT DELTA.
DT1	DATA	>2000	    * RECEIVE DELTA.
TH1	DATA	>0009	    *  0.01  Q12 TRSHD FOR CARRIER
TH2	DATA	>0020	    *  0.01  Q12 TRSHD FOR BAUD CLOCK
MIN1	DATA	>F000	    * -1 Q12
PLS1	DATA	>0FFF	    *  1 Q12
SINTBL	DATA	SINE
*
       PAGE
*     ANSWER MODE HILBERT TRANSFORM COEFFICIENTS
ACEQU  DATA 29059	   A11
       DATA -14492	   A12
       DATA 10922	   B10
       DATA -21901	   B11
       DATA 24696	   B12
       DATA 18983	   A21
       DATA -19586	   A22
       DATA 16384	   B20
       DATA -15879	   B21
       DATA 27410	   B22
*
*     ORIGINATE MODE HILBERT TRANSFORM COEFFICIENTS
OCEQU  DATA 17810	   A11
       DATA -18620	   A12
       DATA 16384	   B10
       DATA -15671	   B11
       DATA 28833	   B12
       DATA 1394	   A21
       DATA -13237	   A22
       DATA 10922	   B20
       DATA -1150	   B21
       DATA 27038	   B22
*
       PAGE
INISP1 DATA >390F	 SERIAL PORT INITIALIZE
INISP2 DATA >1CBE	 PORT SCALER INITIALIZE
INISP3 DATA >380F	 SET PORT1 TO ACCESS XMIT REG
*
********------------------------------------------********
*****	   DTMF TONE OFFSET VALUE DECODE TABLE	     *****
********------------------------------------------********
*
TONTBL	EQU  $
	DATA >11D,>C9	 TONE FREQ 1336,941 DIGIT 0
	DATA >102,>95	 TONE FREQ 1209,697 DIGIT 1
	DATA >11D,>95	 TONE FREQ 1336,697 DIGIT 2
	DATA >13B,>95	 TONE FREQ 1477,697 DIGIT 3
	DATA >102,>A4	 TONE FREQ 1209,770 DIGIT 4
	DATA >11D,>A4	 TONE FREQ 1336,770 DIGIT 5
	DATA >13B,>A4	 TONE FREQ 1477,770 DIGIT 6
	DATA >102,>B6	 TONE FREQ 1209,853 DIGIT 7
	DATA >11D,>B6	 TONE FREQ 1336,853 DIGIT 8
	DATA >13B,>B6	 TONE FREQ 1477,853 DIGIT 9
	DATA >102,>C9	 TONE FREQ 1209,941 DIGIT *
	DATA >13B,>C9	 TONE FREQ 1477,941 DIGIT #
* TEST TONES
LBSP	DATA >E4	 ANSWER XMIT SPACE  DIGIT /
LBMK	DATA >10F	 ANSWER XMIT MARK   DIGIT .
HBSP	DATA >1B0	 ORIGIN XMIT SPACE  DIGIT ,
HBMK	DATA >1DB	 ORIGIN XMIT MARK   DIGIT ;
*
********------------------------------------------********
*****	PLL LOOP FILTER COFFECIENTS.		     *****
********------------------------------------------********
*
PLLC1	DATA	>4500	* Q15	CARRIER PLL COEFFICIENTS
PLLC2	DATA	>80	* Q15	CARRIER PLL COEFFICIENTS
BPLLC1	DATA	>4000	* Q15	BAUD CLOCK PLL COEFFICIENTS
BPLLC2	DATA	>50	* Q15	BAUD CLOCK PLL COEFFICIENTS
PLLC	DATA	>7A00
BPLLC	DATA	>7500
*
**********----------------------------------------********
*****	TASK MASTER SEQUENCE TABLE  (RECEIVE)	     *****
*****	TASKS ARE EXECUTED FROM BOTTOM TO TOP	     *****
**********----------------------------------------********
*
TSKSEQ	EQU  $
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	15
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	14
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	13
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	12
	DATA BDCLK2   SHIFT BIT2 IN, DESCRM,XMIT TO DTE 11
	DATA TRENDS   UPDATE CARRIER STEP		10
	DATA OUT      OUTPUT DIBIT TO 7000		 9
	DATA DECODE   DECODE PHASE SHIFT, CORRECT PHASE  8
	DATA DEMODB   DEMODULATE FOR BAUD		 7
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	 6
	DATA AGCUPT   UPDATE THE AUTOMATIC GAIN FACTOR	 5
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	 4
	DATA BDCLK1   SHIFT BIT1 IN, DESCRM, XMIT TO DTE 3
	DATA DEBUG    DUMMY CYCLE, DEMOD FOR DEBUG	 2
	DATA DUMMY    DUMMY CYCLE, DEMOD FOR DEBUG	 1
	DATA BAUDST   SHOW BAUD START,DEMOD FOR DEBUG	 0
*
**********----------------------------------------********
*****	TASK MASTER SEQUENCE TABLE  (TRANSMIT)	     *****
*****	TASKS ARE EXECUTED FROM BOTTOM TO TOP	     *****
**********----------------------------------------********
*
TSKXMT	EQU  $
	DATA GETDBT   GET THE NEXT DIBIT		16
	DATA DUMXMT   NO CYCLE				15
	DATA DUMXMT   NO CYCLE				14
	DATA DUMXMT   NO CYCLE				13
	DATA DUMXMT   NO CYCLE				12
	DATA DUMXMT   NO CYCLE				11
	DATA DUMXMT   NO CYCLE				10
	DATA DUMXMT   NO CYCLE				 9
	DATA DUMXMT   NO CYCLE				 8
	DATA DUMXMT   NO CYCLE				 7
	DATA DUMXMT   NO CYCLE				 6
	DATA DUMXMT   NO CYCLE				 5
	DATA DUMXMT   NO CYCLE				 4
	DATA DUMXMT   NO CYCLE				 3
	DATA DUMXMT   NO CYCLE				 2
	DATA DUMXMT   NO CYCLE				 1
	PAGE
**********************************************************
*****	320 BASED BELL 103 MODEM DATA AREA	     *****
**********************************************************
*
*************************************************
*  ORIGINATE BANDPASS COEFFICIENT STORAGE AREA	*
*************************************************
*
*  SECOND-ORDER SECTION #  1  ORIGINATE BANDPASS
*
ORGCOF DATA 19382	   26  SECTION 1 B0
       DATA 10271	   27  SECTION 1 B1
       DATA 5509	   28  SECTION 1 A1
       DATA -28378	   29  SECTION 1 A2
       DATA 19382	   2A  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ORIGINATE BANDPASS
*
       DATA 20760	   2B  SECTION 2 B0
       DATA 4596	   2C  SECTION 2 B1
       DATA 3036	   2D  SECTION 2 A1
       DATA -29383	   2E  SECTION 2 A2
       DATA 20760	   2F  SECTION 2 B2
*
*  SECOND-ORDER SECTION #  3  ORIGINATE BANDPASS
*
       DATA 14999	   30  SECTION 3 B0
       DATA -16860	   31  SECTION 3 B1
       DATA 8099	   32  SECTION 3 A1
       DATA -29479	   33  SECTION 3 A2
       DATA 14999	   34  SECTION 3 B2
*
*  SECOND-ORDER SECTION #  4  ORIGINATE BANDPASS
*
       DATA 26693	   35  SECTION 4 B0
       DATA 0		   36  SECTION 4 B1
       DATA 1744	   37  SECTION 4 A1
       DATA -31573	   38  SECTION 4 A2
       DATA -26693	   39  SECTION 4 B2
*
*  SECOND-ORDER SECTION #  5  ORIGINATE BANDPASS
*
       DATA 19635	   35  SECTION 5 B0
       DATA -17383	   36  SECTION 5 B1
       DATA 9676	   37  SECTION 5 A1
       DATA -31626	   38  SECTION 5 A2
       DATA 19635	   39  SECTION 5 B2
*
	PAGE
*************************************************
*  ORIGINATE SPACE COEFFICIENT STORAGE AREA	*
*************************************************
*
*  SECOND-ORDER SECTION #  1  ORIGINATE SPACE
*
ORGSPC DATA 31250	   35  SECTION 1 B0
       DATA -1498	   36  SECTION 1 B1
       DATA 8240	   37  SECTION 1 A1
       DATA -28707	   38  SECTION 1 A2
       DATA 31237	   39  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ORIGINATE SPACE
*
       DATA 13650	   3A  SECTION 2 B0
       DATA -20813	   3B  SECTION 2 B1
       DATA 19790	   3C  SECTION 2 A1
       DATA -29475	   3D  SECTION 2 A2
       DATA 13646	   3E  SECTION 2 B2
*
	PAGE
*************************************************
*  ORIGINATE MARK COEFFICIENT STORAGE AREA	*
*************************************************
*
*  SECOND-ORDER SECTION #  1  ORIGINATE MARK
*
ORGMRK DATA 16779	   44  SECTION 1 B0
       DATA -10879	   45  SECTION 1 B1
       DATA 2735	   46  SECTION 1 A1
       DATA -28689	   47  SECTION 1 A2
       DATA 16772	   48  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ORIGINATE MARK
*
       DATA 25155	   49  SECTION 2 B0
       DATA 27427	   4A  SECTION 2 B1
       DATA -10768	   4B  SECTION 2 A1
       DATA -28916	   4C  SECTION 2 A2
       DATA 25146	   4D  SECTION 2 B2
*
	PAGE
*************************************************
*     ANSWER COEFFICIENT STORAGE AREA		*
*************************************************
*	   THESE FILTERS NEED REDESIGN
*  SECOND-ORDER SECTION #  1  ANSWER
*
ANSCOF DATA 17011	   26  SECTION 1 B0
       DATA 0		   27  SECTION 1 B1
       DATA 22234	   28  SECTION 1 A1
       DATA -28519	   29  SECTION 1 A2
       DATA -17011	   2A  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ANSWER
*
       DATA 20101	   2B  SECTION 2 B0
       DATA -13084	   2C  SECTION 2 B1
       DATA 20602	   2D  SECTION 2 A1
       DATA -29315	   2E  SECTION 2 A2
       DATA 20201	   2F  SECTION 2 B2
*
*  SECOND-ORDER SECTION #  3  ANSWER
*
       DATA 11962	   30  SECTION 3 B0
       DATA -21659	   31  SECTION 3 B1
       DATA 24342	   32  SECTION 3 A1
       DATA -29841	   33  SECTION 3 A2
       DATA 11962	   34  SECTION 3 B2
*
*  SECOND-ORDER SECTION #  4  ANSWER
*
       DATA 21228	   35  SECTION 4 B0
       DATA -20833	   36  SECTION 4 B1
       DATA 20208	   37  SECTION 4 A1
       DATA -31533	   38  SECTION 4 A2
       DATA 21228	   39  SECTION 4 B2
*
*  SECOND-ORDER SECTION #  5  ANSWER
*
       DATA 11313	   35  SECTION 5 B0
       DATA -19508	   36  SECTION 5 B1
       DATA 25844	   37  SECTION 5 A1
       DATA -31812	   38  SECTION 5 A2
       DATA 11313	   39  SECTION 5 B2
*
       PAGE
*************************************************
*     ANSWER SPACE COEFFICIENT STORAGE AREA	*
*************************************************
*
*  SECOND-ORDER SECTION #  1  ANSWER SPACE
*
ANSSPC DATA 19349	   35  SECTION 1 B0
       DATA 19349	   36  SECTION 1 B1
       DATA 11546	   37  SECTION 1 A1
       DATA 0		   38  SECTION 1 A2
       DATA 0		   39  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ANSWER SPACE
*
       DATA 23041	   3A  SECTION 2 B0
       DATA -29668	   3B  SECTION 2 B1
       DATA 23733	   3C  SECTION 2 A1
       DATA -29035	   3D  SECTION 2 A2
       DATA 23041	   3E  SECTION 2 B2
*
	PAGE
*************************************************
*     ANSWER MARK COEFFICIENT STORAGE AREA	*
*************************************************
*
*  SECOND-ORDER SECTION #  1  ANSWER MARK
*
ANSMRK DATA 28581	   44  SECTION 1 B0
       DATA 2478	   45  SECTION 1 B1
       DATA 8248	   46  SECTION 1 A1
       DATA -27934	   47  SECTION 1 A2
       DATA 28581	   48  SECTION 1 B2
*
*  SECOND-ORDER SECTION #  2  ANSWER MARK
*
       DATA 13089	   49  SECTION 2 B0
       DATA -21083	   4A  SECTION 2 B1
       DATA 20337	   4B  SECTION 2 A1
       DATA -28929	   4C  SECTION 2 A2
       DATA 13089	   4D  SECTION 2 B2
*
	PAGE
********------------------------------------------********
*****	   RAISED COSINE COEFFICIENT TABLE.	     *****
********------------------------------------------********
COEF	DATA	>1
	DATA	>49A
	DATA	>394
	DATA	>FFD9
	DATA	>5A2
	DATA	>29A
	DATA	>FFAB
	DATA	>6A0
	DATA	>1B5
	DATA	>FF7A
	DATA	>789
	DATA	>ED
	DATA	>FF4C
	DATA	>853
	DATA	>45
	DATA	>FF27
	DATA	>8F4
	DATA	>FFC3
	DATA	>FF11
	DATA	>963
	DATA	>FF65
	DATA	>FF10
	DATA	>99C
	DATA	>FF2A
	DATA	>FF2A
	DATA	>99C
	DATA	>FF10
	DATA	>FF65
	DATA	>963
	DATA	>FF11
	DATA	>FFC3
	DATA	>8F4
	DATA	>FF27
	DATA	>45
	DATA	>853
	DATA	>FF4C
	DATA	>ED
	DATA	>789
	DATA	>FF7A
	DATA	>1B5
	DATA	>6A0
	DATA	>FFAB
	DATA	>29A
	DATA	>5A2
	DATA	>FFD9
	DATA	>394
	DATA	>49A
	DATA	>1
*
	PAGE
***********************************************************
*****  AGC DIVIDE LOOKUP TABLE			      *****
*****	 STANDARD GAIN RANGE -- >3CC3 - >3F79	      *****
*****	 WITH 5% SIGNAL VARIATION -- >3966 - >41D6    *****
*****						      *****
***********************************************************
AGCTBL EQU  $-32	  AGC TABLE LENGTH =  32
       DATA >F8 		   0.9687500
       DATA >F0 		   0.9375000
       DATA >EA 		   0.9140625
       DATA >E3 		   0.8867188 35 -
       DATA >DD 		   0.8632812
       DATA >D7 		   0.8398438
       DATA >D2 		   0.8203125
       DATA >CC 		   0.7968750 39 -
       DATA >C7 		   0.7773438
       DATA >C3 		   0.7617188
       DATA >BE 		   0.7421875
       DATA >BA 		   0.7265625 43 -
       DATA >B6 		   0.7109375
       DATA >B2 		   0.6953125
       DATA >AE 		   0.6796875
       DATA >AA 		   0.6640625 47 -
       DATA >A7 		   0.6523438
       DATA >A3 		   0.6367188
       DATA >A0 		   0.6250000
       DATA >9D 		   0.6132813 51 -
       DATA >9A 		   0.6015625
       DATA >97 		   0.5898438
       DATA >94 		   0.5781250
       DATA >92 		   0.5703125 55 -
       DATA >8F 		   0.5585938
       DATA >8D 		   0.5507813
       DATA >8A 		   0.5390625
       DATA >88 		   0.5312500 59 -
       DATA >86 		   0.5234375
       DATA >84 		   0.5156250
       DATA >82 		   0.5078125
       DATA >7F 		   0.4960938 63 -
       DATA >7D
       DATA >7B
       DATA >79
       DATA >77
       DATA >75
       DATA >73
       DATA >71
       DATA >6F
       PAGE
*
********------------------------------------------********
*****		SINE(COSINE) TABLE		     *****
********------------------------------------------********
SINE	DATA	>0
	DATA	>648
	DATA	>C8C
	DATA	>12C8
	DATA	>18F9
	DATA	>1F1A
	DATA	>2528
	DATA	>2B1F
	DATA	>30FC
	DATA	>36BA
	DATA	>3C57
	DATA	>41CE
	DATA	>471D
	DATA	>4C40
	DATA	>5134
	DATA	>55F6
	DATA	>5A82
	DATA	>5ED7
	DATA	>62F2
	DATA	>66D0
	DATA	>6A6E
	DATA	>6DCA
	DATA	>70E3
	DATA	>73B6
	DATA	>7642
	DATA	>7885
	DATA	>7A7D
	DATA	>7C2A
	DATA	>7D8A
	DATA	>7E9D
	DATA	>7F62
	DATA	>7FD9
COSINE	DATA	>7FFF
	DATA	>7FD9
	DATA	>7F62
	DATA	>7E9D
	DATA	>7D8A
	DATA	>7C2A
	DATA	>7A7D
	DATA	>7885
	DATA	>7642
	DATA	>73B6
	DATA	>70E3
	DATA	>6DCA
	DATA	>6A6E
	DATA	>66D0
	DATA	>62F2
	DATA	>5ED7
	DATA	>5A82
	DATA	>55F6
	DATA	>5134
	DATA	>4C40
	DATA	>471D
	DATA	>41CE
	DATA	>3C57
	DATA	>36BA
	DATA	>30FC
	DATA	>2B1F
	DATA	>2528
	DATA	>1F1A
	DATA	>18F9
	DATA	>12C8
	DATA	>C8C
	DATA	>648
	DATA	>0
	DATA	>F9B8
	DATA	>F374
	DATA	>ED38
	DATA	>E707
	DATA	>E0E6
	DATA	>DAD8
	DATA	>D4E1
	DATA	>CF04
	DATA	>C946
	DATA	>C3A9
	DATA	>BE32
	DATA	>B8E3
	DATA	>B3C0
	DATA	>AECC
	DATA	>AA0A
	DATA	>A57E
	DATA	>A129
	DATA	>9D0E
	DATA	>9930
	DATA	>9592
	DATA	>9236
	DATA	>8F1D
	DATA	>8C4A
	DATA	>89BE
	DATA	>877B
	DATA	>8583
	DATA	>83D6
	DATA	>8276
	DATA	>8163
	DATA	>809E
	DATA	>8027
	DATA	>8001
	DATA	>8027
	DATA	>809E
	DATA	>8163
	DATA	>8276
	DATA	>83D6
	DATA	>8583
	DATA	>877B
	DATA	>89BE
	DATA	>8C4A
	DATA	>8F1D
	DATA	>9236
	DATA	>9592
	DATA	>9930
	DATA	>9D0E
	DATA	>A129
	DATA	>A57E
	DATA	>AA0A
	DATA	>AECC
	DATA	>B3C0
	DATA	>B8E3
	DATA	>BE32
	DATA	>C3A9
	DATA	>C946
	DATA	>CF04
	DATA	>D4E1
	DATA	>DAD8
	DATA	>E0E6
	DATA	>E707
	DATA	>ED38
	DATA	>F374
	DATA	>F9B8
*
	PAGE
************************************************************
******		Initializtion routine		      ******
************************************************************
START  DINT
       LDPK 0		 SET DATA PAGE TO 0
       ROVM		 RESET OVERFLOW MODE
       CALL SETUPO	 INITIALIZE FOR 1200 ORIGINATE
*
       LAC  ONE,4	SET COUNTER VALUE TO RUN
       SACL TEMP	DLB AT 600 BAUD
COMD   EQU  $
       CALL ANALOG	CALL ANALOG ACCESS ROUTINE
*
LOOK   NOP
LOOK1  IN   XMTD,PA7	LOOK FOR COMMAND
       LACK >30 	MASK OFF ALL BUT COMMAND BITS
       AND  XMTD	CHECK COMMAND BITS FOR NEW COMMAND
       BZ   COMD	IF ZERO THEN NO COMMAND YET
       SUB  ONE,4	CHECK FOR DIAL COMMAND
       BZ   DIAL	IF SO THEN EXECUTE TEST
       SUB  ONE,4	CHECK FOR MODEM RUN COMMAND
       BNZ  LOOK3	IF NOT MUST BE NEW CONFIGURATION
       LACK >80 	CHECK ANSWER/ORIGINATE BIT
       AND  RECST	OF STATUS REGISTER
       BZ   RUNAM	IF 0 THEN ANSWER MODE
       CALL SETUPO	ELSE INITIALIZE TO ORIGINATE
       B    RUN12	AND RUN
RUNAM  CALL SETUPA	INITIALIZE TO ANSWER MODE
       B    RUN12	AND RUN IT
LOOK3  LACK >F		MASK OFF COMMAND BITS
       AND  XMTD	TO GET SPECIFIC CONFIGURATION
*   THIS IS FOR CONFIGURATION CODES
       BZ   RUN12	RUN THE MODEM AT 1200		   0
       SUB  ONE 	CHECK FOR COMMAND ONE
       BZ   LDLB	RUN LOCAL DIGITAL LOOP BACK	   1
       SUB  ONE 	CHECK FOR COMMAND TWO
       BZ   RUNALB	SETUP THE MODEM TO RUN ALB	   2
       SUB  ONE 	CHECK FOR COMMAND THREE
       BZ   SETORG	SET UP MODEM TO RUN ORIGINATE MODE 3
       SUB  ONE 	CHECK FOR COMMAND FOUR
       BZ   SETANS	SET UP MODEM TO RUN ANSWER MODE    4
       SUB  ONE 	CHECK FOR COMMAND FIVE
       BZ   RUN103	RUN MODEM AT 300BPS		   5
       ADD  ONE 	*(12-5+1)=8
       SUB  ONE,3	CHECK FOR COMMAND 12
       BZ   RUN12A	RUN 1200 ANSWER INITIALIZATION	  12
       SUB  ONE 	CHECK FOR COMMAND 13
       BZ   RSQ103	RUN 300BPS MODEM SQUELCH XMT	  13
       B    COMD	CHECK FOR NEXT COMMAND
RUNALB LAC  ONE,13	LOAD ACC WITH 2000 TO PUT
       SACL XDELTA	XMIT IN SAME BAND AS RECEIVE
       B    WAIT	CHECK FOR NEXT COMMAND
SETORG EQU  $
       LACK >A0 	SET ANS-/ORG BIT AND ENERGY DETECT
       SACL RECST	BIT IN RECST FOR ORG MODE
       CALL SETUPO	INITIALIZE TO ORIGINATE MODE
       B    COMD	CHECK FOR NEXT COMMAND
*
*  THE SETANS WILL NOT WORK UNTIL THE BAND FILTERS
*  ARE REMOVED FROM THE CODE
SETANS LACK >24 	SET ANS-/ORG, EDT & ANS TONE ENABLE
       SACL RECST	IN THE RECIEVE STATUS REGISTER
       CALL SETUPA	INITIALIZE TO ANSWER MODE
       B    COMD	CHECK FOR NEXT COMMAND
*
LDLB   LAC  ONE,4	RESET COUNTER VALUE TO RUN
       SACL SAMPLE	DLB AT 600 BAUD
LDLB1  CALL ANALOG	WAIT FOR NEXT SAMPLE PERIOD
DLBOUT EQU  $
       LAC  SAMPLE	GET 16 SAMPLE BAUD COUNTER
       SUB  ONE 	DECREMENT IT
       SACL SAMPLE	SAVE COUNT
       BNZ  LDLB1	COUNT ANOTHER SAMPLE PERIOD
       OUT  XMTD,PA7	ECHO INPUT
       NOP		DUMMY
       IN   XMTD,PA7	GET NEXT DIBIT
       LACK >30 	MASK OFF ALL BUT COMMAND BITS
       AND  XMTD	CHECK COMMAND BITS FOR SQUELCH
       BZ   COMD	IF SQUELCH KILL LDLB
       B    LDLB	ELSE CONTINUE RUNNING
*
       PAGE
*  THIS ROUTINE INITIALIZES/REINITIALIZES THE MODEM REGS
SETUPA EQU  $	 FOR ANSWER MODEM
*	  INITIALIZE CARRIER FREQUENCY CONTROLLERS
       LACK DT		 GET TRANSMIT RANGE
       TBLR RDELTA	 AND STORE FOR REFERENCE
       ADD  ONE 	 GET RECEIVE RANGE
       TBLR XDELTA	 AND STORE FOR REFERENCE
       LACK ACEQU	 POINT TO EQUALIZER COEFS
       B    SETUP	 CONTINUE SETUP
*
SETUPO EQU  $	 FOR ORIGINATE MODEM
*	  INITIALIZE CARRIER FREQUENCY CONTROLLERS
       LACK DT		 GET TRANSMIT RANGE
       TBLR XDELTA	 AND STORE FOR REFERENCE
       ADD  ONE 	 GET RECEIVE RANGE
       TBLR RDELTA	 AND STORE FOR REFERENCE
       LACK OCEQU	 POINT TO EQUALIZER COEFS
*
SETUP  EQU  $
*    LOAD IN EQUALIZER COEFFICIENTS
       LDPK 1		   EQUALIZER RUNS FROM DATA PAGE 1
       TBLR A11
       ADD  ONE
       TBLR A12
       ADD  ONE
       TBLR B10
       ADD  ONE
       TBLR B11
       ADD  ONE 	 READ IN THE
       TBLR B12 	 COMPROMISE EQUALIZER
       ADD  ONE 	 COEFFICIENTS
       TBLR A21 	 FROM THE APPROPIATE
       ADD  ONE 	 TABLE
       TBLR A22
       ADD  ONE
       TBLR B20
       ADD  ONE
       TBLR B21
       ADD  ONE
       TBLR B22
       LACK 0		   CLEAR OUT THE
       SACL R1Z1	   EQUALIZER DELAY
       SACL R1Z2	   EQUALIZER DELAY
       SACL R2Z1	   EQUALIZER DELAY
       SACL R2Z2	   EQUALIZER DELAY
       LDPK 0
       SACL BEROUT	   BAUD ALLIGNMENT FACTOR
       SACL ERRSIG	   CARRIER RECOVER ADJUSTMENT
*
       LACK 1		 SET UP SHIFTABLE INCREMENT
       SACL ONE 	 VALUE FOR MASKING AND INCS
       LACK M1		 LOAD IN AND MASK OF >7FFF
       TBLR MASK1	 TO MASK OFF MSB
       LACK M2		 LOAD IN AND MASK OF >007F
       TBLR MASK2	 TO MASK OFF ALL BUT 7 BITS
       LACK M3		 LOAD IN AND MASK OF >0006
       TBLR MASK3	 TO MASK OFF DIBIT FOR TBLR
       LACK MIN1	 LOAD IN Q12 -1 VALUE FOR
       TBLR MINUS1	 EASY COMPARISON
       LACK PLS1	 LOAD IN Q12 +1 VALUE FOR
       TBLR PLUS1	 EASY COMPARISON
*
*    INITIALIZE THE 32011 SERIAL PORT
       LACK INISP1	 GET SERIAL PORT INIT TABLE
       TBLR TEMP	 LOAD THE INITIAL CONTROL
       OUT  TEMP,PA0	 REG SETTING
       ADD  ONE 	 PUT THE CLOCK/COUNTER
       TBLR TEMP	 VALUE SETTING INTO
       OUT  TEMP,PA1	 THE CONTROL REG
       ADD  ONE 	 RESET THE BIT 8 IN CONTROL
       TBLR TEMP	 REG TO ALLOW ACCESS TO
       OUT  TEMP,PA0	 THE TRANSMIT REGISTER
       LACK 0		 INITIALIZE THE TRANSMISSION
       SACL TEMP	 TO THE CODEC TO BE
       OUT  TEMP,PA1	 A LOW LEVEL SIGNAL
*
       LACK SINTBL	 LOAD OFSET0 POINTER WITH
       TBLR OFSET0	 ADDRESS OF SINE TABLE
       LACK ENCODE	 STORE PHASE ENCODE TBL START
       SACL OFSET1	 FOR EASY TABLE LOOKUP
       LACK COEF	 STORE RAISED COS COEF START
       SACL XPTR	 FOR EASY TABLE LOOKUP
       LACK XPHASE	 STORE XMIT PHASE START
       SACL INDXPH	 FOR EASY TABLE LOOKUP
       LACK RPHASE	 STORE RECV PHASE START
       SACL RPHSE	 FOR EASY TABLE LOOKUP
       ZAC		 MISC. INITIALIZATIONS.
       SACL ERNM1	 CLEAR CARRIER RECOVER PLL TAP
       SACL ERNM2	 CLEAR CLOCK RECOVER PLL TAP
       SACL ROLDPH	 CLEAR OLD ABSOLUTE PHASE
*
*	  INITIALIZE CARRIER LOOKUP POSITION
       SACL RALPHA	 CLEAR RECEIVE POSITION
       SACL XALPHA	 CLEAR TRANSMIT POSITION
*
*
       LACK TH1 	 GET PPL THRESHOLD INDICATORS
       TBLR TRSHD1	 STORE CARRIER THRESHOLD
       ADD  ONE 	 AND
       TBLR TRSHD2	 STORE CLOCK THRESHOLD
*-------------------------------
*  LOAD IN PHASE LOCK LOOP COEFFICIENTS
	LACK	PLLC1	 STORE CARRIER COEF1
	TBLR	PLL1	 FOR EASY ACCESS
	ADD	ONE	 STORE CARRIER COEF2
	TBLR	PLL2	 FOR EASY ACCESS
	ADD	ONE	 STORE CLOCK COEF1
	TBLR	BPLL1	 FOR EASY ACCESS
	ADD	ONE	 STORE CLOCK COEF2
	TBLR	BPLL2	 FOR EASY ACCESS
*--------------------------------
	LACK	AGCTBL	 SET THE AGC TABLE LOOKUP
	SACL	AGCOFF	 OFF SET VALUE
	LAC	ONE,13	 INITIALIZE RUNNING AVERAGE
	SACL	AGCRA	 TO >2000
	LACK	>FF	 INITIALIZE THE AGC FACTOR
	SACL	AGC	 TO ONE
	ZAC		 INITIALIZE THE
	SACL	BSMAX	 BAUD SIGNAL MAX TO ZERO
	LACK	3	 RUNNING AVERAGE COUNT
	SACL	AGCNT	 TO THREE
	LACK	15	 SET THE REC SAMPLE COUNT
	SACL	SAMPLE	 TO 16
	LACK	16	 SET THE CARRIER TREND
	SACL	TRNDCT	 BAUD COUNT TO 16
	ZAC		 SET THE XMT SAMPLE COUNT
	SACL	SAMXMT	 TO ZERO
	SACL	CTRND	 CLEAR OUT CARRIER TREND
	SACL	DBUGC	 CLEAR OUT INITIAL BAUD COUNT
	SACL	DBUGC2
	SACL	HIST1
	SACL	HIST2
*
	RET
*
	PAGE
	END
